## lcov-util-0.1.6.crate

=== benchsuite/Makefile ===
TARGET_DIR = target
LCOV_DIR = $(shell readlink -f lcov)
PROFILE_DIR = $(LCOV_DIR)/tests/profiles

TRACEFILE_NAME=full.info part1.info part2.info target.info zero.info
TRACEFILE_small=$(patsubst %,$(TARGET_DIR)/tracefiles/small/%,$(TRACEFILE_NAME))
TRACEFILE_medium=$(patsubst %,$(TARGET_DIR)/tracefiles/medium/%,$(TRACEFILE_NAME))
TRACEFILE_large=$(patsubst %,$(TARGET_DIR)/tracefiles/large/%,$(TRACEFILE_NAME))

PROFILE=

all:
.PHONY: all

all: run-small run-medium run-large

clean:
	$(RM) -r $(TARGET_DIR)
.PHONY: clean

run-%: PROFILE=$(patsubst run-%,%,$@)
run-%:
	cargo build --release
	$(MAKE) measure-lcov-master PROFILE=$(PROFILE)
	$(MAKE) measure-lcov-installed PROFILE=$(PROFILE)
	$(MAKE) measure-lcov-merge PROFILE=$(PROFILE)

gen-tracefile: $(TARGET_DIR)/tracefiles/$(PROFILE)/.generated
.PHONY: gen-tracefile
$(TARGET_DIR)/tracefiles/%/.generated: $(PROFILE_DIR)/% | $(TARGET_DIR)/tracefiles/%/
	if [ -z "$(PROFILE)" ]; then echo "PROFILE is not specified"  ; exit 1; fi
	cd $(TARGET_DIR)/tracefiles/$(PROFILE) && $(LCOV_DIR)/tests/bin/mkinfo "$(PROFILE_DIR)/$(PROFILE)" -o src
	touch $@

measure-lcov-master: $(TARGET_DIR)/results/$(PROFILE)/lcov-master
$(TARGET_DIR)/results/%/lcov-master: $(TARGET_DIR)/tracefiles/%/.generated | $(TARGET_DIR)/results/%/
	/usr/bin/time -p $(LCOV_DIR)/bin/lcov --rc lcov_branch_coverage=1 $(patsubst %,-a %,$(TRACEFILE_$(PROFILE))) -o $@.info 2>$@
	$(LCOV_DIR)/bin/lcov --version > $@.version

measure-lcov-installed: $(TARGET_DIR)/results/$(PROFILE)/lcov-installed
$(TARGET_DIR)/results/%/lcov-installed: $(TARGET_DIR)/tracefiles/%/.generated | $(TARGET_DIR)/results/%/
	/usr/bin/time -p lcov --rc lcov_branch_coverage=1 $(patsubst %,-a %,$(TRACEFILE_$(PROFILE))) -o $@.info 2>$@
	lcov --version > $@.version

measure-lcov-merge: $(TARGET_DIR)/results/$(PROFILE)/lcov-merge
$(TARGET_DIR)/results/%/lcov-merge: $(TARGET_DIR)/tracefiles/%/.generated | $(TARGET_DIR)/results/%/
	/usr/bin/time -p ../target/release/lcov-merge $(TRACEFILE_$(PROFILE)) > $@.info 2>$@
	../target/release/lcov-merge --version > $@.version

%/:
	mkdir -p $@

=== dist/rpm/Makefile ===
define query-cargo-metadata
$(shell rq -tJ "$(2)" < $(1) --format compact | jq -r '.')
endef

PKG_MANIFEST=../../Cargo.toml
PKG_NAME=$(call query-cargo-metadata,$(PKG_MANIFEST),map(m => m.package.name))
PKG_VERSION=$(call query-cargo-metadata,$(PKG_MANIFEST),map(m => m.package.version))
PKG_RELEASE=0
PKG_SUMMARY=$(call query-cargo-metadata,$(PKG_MANIFEST),map(m => m.package.description))
PKG_DESCRIPTION=$(call query-cargo-metadata,$(PKG_MANIFEST),map(m => m.package.description))
PKG_LICENSE=$(call query-cargo-metadata,$(PKG_MANIFEST),map(m => m.package.license))
PKG_VENDOR=$(call query-cargo-metadata,$(PKG_MANIFEST),map(m => m.package.authors[0]))
PKG_GROUP=Applications/Utilities
PKG_URL=$(call query-cargo-metadata,$(PKG_MANIFEST),map(m => m.package.homepage || m.package.repository || m.package.documentation))

PKG=$(PKG_NAME)-$(PKG_VERSION)

WORKDIR:=target
RPMBUILD:=$(WORKDIR)/rpmbuild
REPOROOT:=$(shell git rev-parse --show-toplevel)

ORIG_HOME:=$(HOME)

all: build
.PHONY: all

clean:
	$(RM) -r $(WORKDIR)
.PHONY: clean

build: export RUSTUP_HOME=$(ORIG_HOME)/.rustup
build: export CARGO_HOME=$(ORIG_HOME)/.cargo
build: export HOME=$(shell readlink -f $(WORKDIR))
build: $(RPMBUILD)/SPECS/$(PKG).spec $(RPMBUILD)/SOURCES/master.tar.gz
	rpmbuild -bb \
	  $(RPMBUILD)/SPECS/$(PKG).spec \
	  --define "_pkg_name $(PKG_NAME)" \
	  --define "_pkg_version $(PKG_VERSION)" \
	  --define "_pkg_release $(PKG_RELEASE)" \
	  --define "_pkg_summary $(PKG_SUMMARY)" \
	  --define "_pkg_description $(PKG_DESCRIPTION)" \
	  --define "_pkg_license $(PKG_LICENSE)" \
	  --define "_pkg_vendor $(PKG_VENDOR)" \
	  --define "_pkg_group $(PKG_GROUP)" \
	  --define "_pkg_url $(PKG_URL)"
.PHONY: build

rpmbuild-tree: export HOME=$(shell readlink -f $(WORKDIR))
rpmbuild-tree: | $(WORKDIR)/
	rpmdev-setuptree
.PHONY: rpmbuild-tree

$(RPMBUILD)/SPECS/%.spec: package.spec rpmbuild-tree
	cp $< $@
$(RPMBUILD)/SOURCES/master.tar.gz: rpmbuild-tree
	git -C "$(REPOROOT)" archive HEAD --prefix "master/" --output=$(PWD)/$@

%/:
	mkdir -p $@

=== dist/pkgbuild/PKGBUILD ===
# Maintainer: NAKASHIMA, Makoto <makoto.nksm@gmail.com>

pkgname=lcov-util
pkgver=0.1.6
pkgrel=1
pkgdesc="Utility commands to operate and analyze LCOV trace file at blazingly fast."
url="https://github.com/gifnksm/lcov/"
depends=()
makedepends=('cargo')
arch=('i686' 'x86_64')
license=('MIT' 'APACHE')
source=(${pkgname}-${pkgver}.tar.gz::${url}/archive/lcov-util_v${pkgver}.tar.gz)
sha512sums=('1300151ee37781d459fb80518e55c1ae85e75c9dc87175954893dcccc039cb9a0c1316671a66c694e76922993651dd5402308d12125aaa0fe8d0292ed13adfdf')

build() {
  cd "lcov-${pkgname}_v${pkgver}"
  cargo build --release #--locked
}

check() {
  cd "lcov-${pkgname}_v${pkgver}"
  cargo test --release --locked
}

package() {
  cd "lcov-${pkgname}_v${pkgver}"
  install -Dm755 \
    "target/release/lcov-merge" \
    -t "${pkgdir}/usr/bin"
  install -Dm644 README.md -t "${pkgdir}/usr/share/doc/${pkgname}"
  install -Dm644 LICENSE-MIT -t "${pkgdir}/usr/share/licenses/${pkgname}"
}

# vim:set ts=2 sw=2 et:
